Loading...
Searching...
No Matches
pcl::RadiusOutlierRemoval< PointT > Class Template Reference
Module filters

RadiusOutlierRemoval filters points in a cloud based on the number of neighbors they have. More...

`#include <pcl/filters/radius_outlier_removal.h>`

Inheritance diagram for pcl::RadiusOutlierRemoval< PointT >:

## Public Types

using | Ptr = shared_ptr<RadiusOutlierRemoval<PointT> >
using | ConstPtr = shared_ptr<const RadiusOutlierRemoval<PointT> >
Public Types inherited from pcl::FilterIndices< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | Ptr = shared_ptr<FilterIndices<PointT> >
using | ConstPtr = shared_ptr<const FilterIndices<PointT> >
Public Types inherited from pcl::Filter< PointT >
using | Ptr = shared_ptr<Filter<PointT> >
using | ConstPtr = shared_ptr<const Filter<PointT> >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| RadiusOutlierRemoval (bool extract_removed_indices=false)
| Constructor.
void | setRadiusSearch (double radius)
| Set the radius of the sphere that will determine which points are neighbors.
double | getRadiusSearch ()
| Get the radius of the sphere that will determine which points are neighbors.
void | setMinNeighborsInRadius (int min_pts)
| Set the number of neighbors that need to be present in order to be classified as an inlier.
int | getMinNeighborsInRadius ()
| Get the number of neighbors that need to be present in order to be classified as an inlier.
void | setSearchMethod (const SearcherPtr &searcher)
| Provide a pointer to the search object.
void | setNumberOfThreads (unsigned int nr_threads=0)
| Set the number of threads to use.
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor.
void | filter (Indices &indices)
| Calls the filtering method and returns the filtered point cloud indices.
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions.
bool | getNegative () const
| Get whether the regular conditions for points filtering should apply, or the inverted conditions.
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
bool | getKeepOrganized () const
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them.
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor.
IndicesConstPtr const | getRemovedIndices () const
| Get the point indices being removed.
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed.
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output.
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Types

using | PointCloud = typename FilterIndices<PointT>::PointCloud
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | SearcherPtr = typename pcl::search::Search<PointT>::Ptr

## Protected Member Functions

void | applyFilter (Indices &indices) override
| Filtered results are indexed by an indices array.
void | applyFilterIndices (Indices &indices)
| Filtered results are indexed by an indices array.
Protected Member Functions inherited from pcl::FilterIndices< PointT >
void | applyFilter (PointCloud &output) override
| Abstract filter method for point cloud.
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Additional Inherited Members

Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_ {false}
| False = normal filter behavior (default), true = inverted behavior.
bool | keep_organized_ {false}
| False = remove points (default), true = redefine points, keep structure.
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN).
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed.
std::string | filter_name_
| The filter name.
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points.
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointT>
class pcl::RadiusOutlierRemoval< PointT >

RadiusOutlierRemoval filters points in a cloud based on the number of neighbors they have.

Iterates through the entire input once, and for each point, retrieves the number of neighbors within a certain radius. The point will be considered an outlier if it has too few neighbors, as determined by setMinNeighborsInRadius(). The radius can be changed using setRadiusSearch().
The neighbors found for each query point will be found amongst ALL points of setInputCloud(), not just those indexed by setIndices(). The setIndices() method only indexes the points that will be iterated through as search query points.
Usage example:

pcl::RadiusOutlierRemoval<PointType> rorfilter (true); // Initializing with true will allow us to extract the removed indices
rorfilter.setInputCloud (cloud_in);
rorfilter.setRadiusSearch (0.1);
rorfilter.setMinNeighborsInRadius (5);
rorfilter.setNegative (true);
rorfilter.filter (*cloud_out);
// The resulting cloud_out contains all points of cloud_in that have 4 or less neighbors within the 0.1 search radius
indices_rem = rorfilter.getRemovedIndices ();
// The indices_rem array indexes all points of cloud_in that have 5 or more neighbors within the 0.1 search radius
pcl::RadiusOutlierRemoval
RadiusOutlierRemoval filters points in a cloud based on the number of neighbors they have.
Definition radius_outlier_removal.h:73

See also
  StatisticalOutlierRemoval

Author
  Radu Bogdan Rusu

Definition at line 72 of file radius_outlier_removal.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT>

using pcl::RadiusOutlierRemoval< PointT >::ConstPtr = shared_ptr<const RadiusOutlierRemoval<PointT> >

Definition at line 83 of file radius_outlier_removal.h.

## PointCloud

template<typename PointT>

using pcl::RadiusOutlierRemoval< PointT >::PointCloud = typename FilterIndices<PointT>::PointCloud

protected

Definition at line 75 of file radius_outlier_removal.h.

## PointCloudConstPtr

template<typename PointT>

using pcl::RadiusOutlierRemoval< PointT >::PointCloudConstPtr = typename PointCloud::ConstPtr

protected

Definition at line 77 of file radius_outlier_removal.h.

## PointCloudPtr

template<typename PointT>

using pcl::RadiusOutlierRemoval< PointT >::PointCloudPtr = typename PointCloud::Ptr

protected

Definition at line 76 of file radius_outlier_removal.h.

## Ptr

template<typename PointT>

using pcl::RadiusOutlierRemoval< PointT >::Ptr = shared_ptr<RadiusOutlierRemoval<PointT> >

Definition at line 82 of file radius_outlier_removal.h.

## SearcherPtr

template<typename PointT>

using pcl::RadiusOutlierRemoval< PointT >::SearcherPtr = typename pcl::search::Search<PointT>::Ptr

protected

Definition at line 78 of file radius_outlier_removal.h.

## Constructor & Destructor Documentation

## RadiusOutlierRemoval()

template<typename PointT>

pcl::RadiusOutlierRemoval< PointT >::RadiusOutlierRemoval | ( | bool | extract_removed_indices = false | ) |

inline

Constructor.

Parameters

  [in] | extract_removed_indices | Set to true if you want to be able to extract the indices of points being removed (default = false).

Definition at line 89 of file radius_outlier_removal.h.

References pcl::Filter< PointT >::filter_name_, and pcl::FilterIndices< PointT >::FilterIndices().

## Member Function Documentation

## applyFilter()

template<typename PointT>

void pcl::RadiusOutlierRemoval< PointT >::applyFilter | ( | Indices & | indices | ) |

inline override protected virtual

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Implements pcl::FilterIndices< PointT >.

Definition at line 179 of file radius_outlier_removal.h.

References applyFilterIndices().

## applyFilterIndices()

template<typename PointT>

void pcl::RadiusOutlierRemoval< PointT >::applyFilterIndices | ( | Indices & | indices | ) |

protected

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Definition at line 49 of file radius_outlier_removal.hpp.

References pcl::Filter< PointT >::extract_removed_indices_, pcl::Filter< PointT >::getClassName(), pcl::PCLBase< PointT >::indices_, pcl::PCLBase< PointT >::input_, pcl::isXYZFinite(), pcl::FilterIndices< PointT >::negative_, and pcl::Filter< PointT >::removed_indices_.

Referenced by applyFilter().

## getMinNeighborsInRadius()

template<typename PointT>

int pcl::RadiusOutlierRemoval< PointT >::getMinNeighborsInRadius | ( |  | ) |

inline

Get the number of neighbors that need to be present in order to be classified as an inlier.

The number of points within setRadiusSearch() from the query point will need to be equal or greater than this number in order to be classified as an inlier point (i.e. will not be filtered).

Returns
  The minimum number of neighbors (default = 1).

Definition at line 135 of file radius_outlier_removal.h.

## getRadiusSearch()

template<typename PointT>

double pcl::RadiusOutlierRemoval< PointT >::getRadiusSearch | ( |  | ) |

inline

Get the radius of the sphere that will determine which points are neighbors.

The number of points within this distance from the query point will need to be equal or greater than setMinNeighborsInRadius() in order to be classified as an inlier point (i.e. will not be filtered).

Returns
  The radius of the sphere for nearest neighbor searching.

Definition at line 113 of file radius_outlier_removal.h.

## setMinNeighborsInRadius()

template<typename PointT>

void pcl::RadiusOutlierRemoval< PointT >::setMinNeighborsInRadius | ( | int | min_pts | ) |

inline

Set the number of neighbors that need to be present in order to be classified as an inlier.

The number of points within setRadiusSearch() from the query point will need to be equal or greater than this number in order to be classified as an inlier point (i.e. will not be filtered).

Parameters

  min_pts | The minimum number of neighbors (default = 1).

Definition at line 124 of file radius_outlier_removal.h.

## setNumberOfThreads()

template<typename PointT>

void pcl::RadiusOutlierRemoval< PointT >::setNumberOfThreads | ( | unsigned int | nr_threads = 0 | ) |

inline

Set the number of threads to use.

Parameters

  nr_threads | the number of hardware threads to use (0 sets the value back to automatic)

Definition at line 152 of file radius_outlier_removal.h.

## setRadiusSearch()

template<typename PointT>

void pcl::RadiusOutlierRemoval< PointT >::setRadiusSearch | ( | double | radius | ) |

inline

Set the radius of the sphere that will determine which points are neighbors.

The number of points within this distance from the query point will need to be equal or greater than setMinNeighborsInRadius() in order to be classified as an inlier point (i.e. will not be filtered).

Parameters

  [in] | radius | The radius of the sphere for nearest neighbor searching.

Definition at line 102 of file radius_outlier_removal.h.

## setSearchMethod()

template<typename PointT>

void pcl::RadiusOutlierRemoval< PointT >::setSearchMethod | ( | const SearcherPtr & | searcher | ) |

inline

Provide a pointer to the search object.

Calling this is optional. If not called, the search method will be chosen automatically.

Parameters

  [in] | searcher | a pointer to the spatial search object.

Definition at line 145 of file radius_outlier_removal.h.

The documentation for this class was generated from the following files:

- pcl/filters/radius_outlier_removal.h
- pcl/filters/impl/radius_outlier_removal.hpp